#!/usr/bin/perl
# usually active state version
# C:/Perl/bin/perl.exe
# usually a mod_perl version
# C:/Perl/5.6.0/bin/MSWin32-x86/perl.exe
#  application: SQL QuickRegister Password Management System
#       script: admin_command.cgi
#      Version: March/2002 1.0
#       author: David Jourard
#               Bytes Interactive
#               http://www.bytesinteractive.com
#               cgi@bytesinteractive.com
# requirements: perl 5 Unix Version and mySQL
#
#
#  description: admin update of client
# ***************************************************************************
# SQL QuickRegister
# COPYRIGHT NOTICE
# Copyright 2002 David Jourard  All Rights Reserved.
#
# This program cannot be used till one reads and agrees the terms of the license
# defined in the file license.txt which comes with the software.
#*****************************************************************************
#Clears data if connection is broken
$|= 1;

use strict;
use vars qw($gvar $cvar $ovar %config $debug $dbh %QEVar @othertemplates);
use Digest::MD5;
use CGI::Cookie;

$debug=0;
if ($debug) {
   print STDOUT "Content-type: text/plain\n\n";
}

#######################################
#     Call Perl Libraries
#######################################
require "startup_quickregister.pl";
require "genlib.pl";
require "mysqllib.pl";

&genlib::OpenParam("$config{'DataPath'}/config.txt", $gvar);
&genlib::OpenParam("$config{'DataPath'}/messages.txt", $gvar);

&ModifyConfig(\@othertemplates, \%QEVar);

my(@file_array)=( 'admin_menu.htm',           #1
                  'update_registrant.htm',    #2
                  'admin_login.htm',          #3
                  'admin1.htm',               #4
                  'admin2.htm',               #5
                  'admin3.htm',               #6
                  'admin_menu.htm',           #7
                  'admin_menu.htm',           #8
                  'admin_menu.htm',           #9
                  'admin_menu.htm',           #10
                  'admin_register.htm'        #11
                );

my %VALUES = &genlib::ParseData();

my ($page) = $file_array[$VALUES{'action'} - 1];


if ($VALUES{'action'} != 1) {
   #######################################
   #     Verify Login Ticket
   #######################################
   my ($result) = ''; my($message) = '';
   ($result, $message) = &genlib::VerifyLoginTicket_Type3();
   if ($result == 0) {
      $ovar->{'message'} = $message;
     $page = $file_array[2];
     &genlib::SetUpTemplates("$config{'HtmlTemplates'}");

     &genlib::InitializeOut();
     &genlib::RdOutFile("$config{'HtmlTemplates'}/$page");
     exit;
   }
}

if ($VALUES{'action'} == 1) {
   if ($VALUES{'password'} ne $config{'adminpassword'}) {
      $ovar->{'message'}="Incorrect Password";
      $page = $file_array[2];
   }
   else {
      # logging in
      my $cookie = &CrtLoginTicket_Type3();
      print "Set-Cookie:$cookie\n";
   }
}
elsif ($VALUES{'action'} == 2) {




   ######################
   # Open SQL Database
   ######################
   &SetDBI();

   my $username=$VALUES{'username'};

   # Find registration data
   if ($debug) { print "action=3\n"; }
   my(@row) = ();  my(@fldnames) = ();
   if (!&FindRecord('register', "*", "username='$username'", \@row, \@fldnames) ) {

      &CloseDBI();
      &genlib::SysSqlError("admin_command.cgi", "User: $username not found register", '', $dbh->err, $dbh->errstr);

   }
   if ($debug) { print "action=3\n"; }
   my($nk) = 0;  my($fld) = '';
   foreach $fld (@fldnames) {
      $ovar->{$fld} = $row[$nk++];
      if ($debug) { print "fld=$fld\n"; }
      if ($debug) { print "fldvl=$ovar->{$fld}\n"; }
   }

   my($var1) = '';
   $var1 = join("_", "slc_state", $ovar->{'state'});
   $ovar->{$var1} = "selected";
   $var1 = join("_", "slc_country", $ovar->{'country'});
   $ovar->{$var1} = "selected";



   $ovar->{'username'} = $VALUES{'username'};
   $ovar->{'fields'} = qq(<input type="hidden" name="username"
value="$VALUES{'username'}">);

   $ovar->{'fields'} .= qq(<input type="hidden" name="letter" value="$VALUES{'letter'}">);
   $ovar->{'fields'} .= qq(<input type="hidden" name="registerdate" value="$ovar->{'registerdate'}">);
   $ovar->{'fields'} .= qq(<input type="hidden" name="activatedate"  value="$ovar->{'activatedate'}">);
   $ovar->{'fields'} .= qq(<input type="hidden" name="updatedate"     value="$ovar->{'updatedate'}">);


   $QEVar{'ACTIVATEDATE'} = 'activatedate';
   $QEVar{'UPDATEDATE'} = 'updatedate';
   $QEVar{'REGISTERDATE'} = 'registerdate';

   $QEVar{'USERNAME'} = 'username';
   $QEVar{'FIELDS'} = 'fields';

   @row = ();
   if (!&FindRecord('recovery', "*", "username='$username'", \@row) ) {

      &CloseDBI();
      &genlib::SysSqlError("admin_command.cgi", "User: $username not found in recovery", '', $dbh->err, $dbh->errstr);

   }
   #$ovar->{'cpassword2'} = $ovar->{'cpassword'} = $row[1];
   $ovar->{'reminder'} = $row[2];


   @row = ();
   if (!&FindRecord('user', "activate", "username='$username'", \@row) ) {

      &CloseDBI();
      &genlib::SysSqlError("admin_command.cgi", "User: $username not found in user", '', $dbh->err, $dbh->errstr);

   }
   if ($row[0] == 1) {
      $ovar->{'activate'} = 'checked';
   }


   &CloseDBI();
}
elsif ($VALUES{'action'} == 4) {
   &genlib::OpenParam("$config{'DataPath'}/config.txt", $ovar);
}
elsif ($VALUES{'action'} == 5) {
   &genlib::OpenParam("$config{'DataPath'}/register.txt", $ovar);
}
elsif ($VALUES{'action'} == 6) {
   &genlib::OpenParam("$config{'DataPath'}/messages.txt", $ovar);
}
elsif ($VALUES{'action'} == 7) {

   &genlib::UpdtParameterFile('config.txt', 'config_template.txt', \%VALUES);

   $ovar->{'message'}="Configuration File: config.txt UPDATED";
}
elsif ($VALUES{'action'} == 8) {

   &genlib::UpdtParameterFile('register.txt', 'register_template.txt', \%VALUES);

   $ovar->{'message'}="Configuration File: register.txt UPDATED";
}
elsif ($VALUES{'action'} == 9) {

   &genlib::UpdtParameterFile('messages.txt', 'messages_template.txt',\%VALUES);

   $ovar->{'message'}="Configuration File: messages.txt UPDATED";
}


&genlib::SetUpTemplates("$config{'HtmlTemplates'}");

&genlib::InitializeOut();
&genlib::RdOutFile("$config{'HtmlTemplates'}/$page");


exit;


sub CrtLoginTicket_Type3 {

   if ($debug) { print "CrtLoginTicket_type3 ....\n"; }

   my($key) = join('', $gvar->{'s_key_today'}, $config{'adminpassword'} );

   my $ctx = Digest::MD5->new;
   $ctx->add($key);
   my($hash) = $ctx->hexdigest;
   #-my($hash) = MD5->hexhash($key);

   $key = join('', $gvar->{'s_key_today'}, $hash);

   $ctx->reset;
   $ctx->add($key);
   $hash = $ctx->hexdigest;
   #-$hash = MD5->hexhash($key);

   return CGI::Cookie->new(-name=>'i8Yw3ewW2zWTet',
                           -path=>'/',
                           -value => $hash
                           );

}

