#!/usr/bin/perl
# usually active state version
# C:/Perl/bin/perl.exe
# usually a mod_perl version
# C:/Perl/5.6.0/bin/MSWin32-x86/perl.exe
#  application: SQL QuickRegister Password Management System
#       script: admin_delete.cgi
#      Version: March/2002 1.0
#       author: David Jourard
#               Bytes Interactive
#               http://www.bytesinteractive.com
#               cgi@bytesinteractive.com
# requirements: perl 5 Unix Version and mySQL
#
#
#  description: admin update of client
# ***************************************************************************
# SQL QuickRegister
# COPYRIGHT NOTICE
# Copyright 2002 David Jourard  All Rights Reserved.
#
# This program cannot be used till one reads and agrees the terms of the license
# defined in the file license.txt which comes with the software.
#*****************************************************************************
#Clears data if connection is broken
$|= 1;

use strict;
use vars qw($gvar $cvar $ovar %config $debug $dbh %QEVar @othertemplates);

$debug=0;
if ($debug) {
   print STDOUT "Content-type: text/plain\n\n";
}

#######################################
#     Call Perl Libraries
#######################################
require "startup_quickregister.pl";
require "genlib.pl";
require "mysqllib.pl";

&genlib::OpenParam("$config{'DataPath'}/config.txt", $gvar);
&genlib::OpenParam("$config{'DataPath'}/messages.txt", $gvar);

&ModifyConfig(\@othertemplates, \%QEVar);

my %VALUES = &genlib::ParseData();


#######################################
#     Verify Admin Login Ticket
#######################################
my ($result) = ''; my($message) = '';
($result, $message) = &genlib::VerifyLoginTicket_Type3();
if ($result == 0) {
   $ovar->{'message'} = $message;
  &genlib::SetUpTemplates("$config{'HtmlTemplates'}");

  &genlib::InitializeOut();
  &genlib::RdOutFile("$config{'HtmlTemplates'}/login.htm");
  exit;
}

my $action = $VALUES{'action'};
my $username = $VALUES{'username'};
my $letter = $VALUES{'letter'};


if ($action == 1) {
   # Display Delete confirmation
   $QEVar{'USERNAME'} = 'username';
   $QEVar{'FIELDS'} = 'fields';

   $ovar->{'username'} = $username;

   $ovar->{'fields'} = qq(<input type="hidden" name="letter" value="$letter">);
   $ovar->{'fields'} .= qq(<input type="hidden" name="username" value="$username">);
   $ovar->{'fields'} .= qq(<input type="hidden" name="action" value="2">);

   &genlib::SetUpTemplates("$config{'HtmlTemplates'}");

   &genlib::InitializeOut();
   &genlib::RdOutFile("$config{'HtmlTemplates'}/confirm_deletion.htm");
}
elsif ($action == 2) {
   # delete
   ######################
   # Open SQL Database
   ######################
   &SetDBI();

   # Delete record from register, user, and recover
   &DelRecord('register', "username='$username'");
   &DelRecord('user', "username='$username'");
   &DelRecord('recovery', "username='$username'");

   ###########################################
   #   Prepare date and time for registration
   ###########################################
   &genlib::CreateDate(\$gvar->{'time'},\$ovar->{'longdate'},\$gvar->{'date'},\$gvar->{'shortdate2'}, \$gvar->{'sqldate'}, \$ovar->{'longtime'});

   &genlib::SetUpTemplates("$config{'HtmlTemplates'}");

   &UpDtUsersTable($VALUES{'letter'});

   &CloseDBI();
}


exit;


sub DelRecord {
  my($sqltable) = $_[0];
  my($searchfor) = $_[1];
  my($lRtrn) = 0;

   if ($debug) { print "DelRecord() ...\n"; }
   if ($debug) { print "   sqltable=$sqltable\n"; }
   if ($debug) { print "   searchfor=$searchfor\n"; }

   my($fld) = ''; my($ni) = 0;


   my $SqlCmd = "DELETE FROM $sqltable WHERE $searchfor";
   if ($debug) { print "   Sqlcmd=$SqlCmd\n"; }
   my $rows = $dbh->do( $SqlCmd );
   if ($debug) { print "rows=$rows\n"; }

   if (!$rows) {
      my $er = join('', "Error: ", $dbh->errstr);
      &genlib::WrError("Qelib - DelRecord", $er);
      &CloseDBI();
      &genlib::SysError("Qelib - DelRecord", $er, $SqlCmd);
   }


   if ($debug) { print "end of DelRecord() ...\n"; }
   return;
}

