#!/usr/bin/perl
# usually active state version
# C:/Perl/bin/perl.exe
# usually a mod_perl version
# C:/Perl/5.6.0/bin/MSWin32-x86/perl.exe
#  application: SQL QuickRegister Password Management System
#       script: command.cgi
#      Version: March/2002
#       author: David Jourard
#               Bytes Interactive
#               http://www.bytesinteractive.com
#               cgi@bytesinteractive.com
# requirements: perl 5 Unix Version and mySQL
#
#
#  description: Control Page for dynamic page creation in admin area
# modification: 10/11/02 Displays username on main_menu.htm
# ***************************************************************************
# SQL QuickRegister
# COPYRIGHT NOTICE
# Copyright 2002 David Jourard  All Rights Reserved.
#
# This program cannot be used till one reads and agrees the terms of the license
# defined in the file license.txt which comes with the software.
#*****************************************************************************
#Clears data if connection is broken
$|= 1;

use strict;
use vars qw($gvar $cvar $ovar %config $debug $dbh %QEVar @othertemplates);
use Time::Local;
use Digest::MD5;
use CGI::Cookie;

$debug=0;
if ($debug) {
   print STDOUT "Content-type: text/plain\n\n";
}

#######################################
#     Call Perl Libraries
#######################################
require "startup_quickregister.pl";
require "genlib.pl";
require "mysqllib.pl";

&genlib::OpenParam("$config{'DataPath'}/config.txt", $gvar);
&genlib::OpenParam("$config{'DataPath'}/messages.txt", $gvar);

&ModifyConfig(\@othertemplates, \%QEVar);

my(@file_array)=( 'register.htm',          #1
                  'update_profile.htm',    #2
                  'login.htm',             #3
                  'retrieve_password.htm', #4
                  'user_agreement.htm',    #5
                  'terminate_response.htm',#6
                  'main_menu.htm'          #7
                );


my(@verifyticket)=( 0,
                    1,
                    0,
                    0,
                    0,
                    1,
                    1
                   );

my %VALUES = &genlib::ParseData();

# Post submissions
if ($VALUES{'agree'}) {
   $VALUES{'action'} = '1';
}
elsif ($VALUES{'disagree'}) {
   $VALUES{'action'} = '3';
}

&genlib::CreateDate(\$gvar->{'time'},\$ovar->{'longdate'},\$gvar->{'date'},\$gvar->{'shortdate2'}, \$gvar->{'sqldate'}, \$ovar->{'longtime'});

my ($page) = $file_array[$VALUES{'action'} - 1];

my $bypass_session_login = 0;
if ($VALUES{'action'} eq $config{'admin_login'}) {
   $page = 'admin_login.htm';
   $bypass_session_login = 1;
}
if (!$page) {
   $VALUES{'action'} = 3;
   $page = 'login.htm';
}





if ($debug) { print "file_array=$file_array[0]\n"; }
if ($debug) { print "page=$page\n"; }
# For custom work
#my($stateid) = &genlib::CreateStateId();
#$ovar->{'fields'} = qq(<input type="hidden" name="stateid" value="$stateid">);



my($username) = ''; my $sessiontime = 0;
if ($verifyticket[$VALUES{'action'} - 1] && !$bypass_session_login) {
   #######################################
   #     Verify Login Ticket
   #######################################
   my ($result) = ''; my($message) = '';
   ($result, $message, $username, $sessiontime) = &genlib::VerifyLoginTicket();

   if (!$result) {
      $ovar->{'message'} = $message;
      $page='login_error.htm';
   }
}


if ($page eq 'login.htm' && $gvar->{'UseAutoLogin'} == 1) {

   # Automatic login ticket


     my %aCookies = &genlib::GetCookies();

     if ($debug) { print "tick_type1=$aCookies{'Ticket'}\n"; }

     if ($aCookies{'Ticket'}) {
        my(@stuff) = split(/&/, $aCookies{'Ticket'});

        my $ni = 0; my(%Tick) = ();
        for($ni=0; $ni<=$#stuff; $ni+=2) {
           if ($debug) { print "name=$stuff[$ni]\n"; }
           if ($debug) { print "value=$stuff[$ni+1]\n"; }
           $Tick{$stuff[$ni]} = $stuff[$ni+1];
        }

        &genlib::OpenParam("$config{'DataPath'}/register.txt", $gvar);
        my $LoginHtml = $gvar->{'LoginHtml1'};

        #######################################
        #     Open DBI Connection
        #######################################
        &SetDBI();
        my $username = $Tick{'who'};
        my $password = $Tick{'how'};
        my $salt = substr($password,0,2);
        my $cryptpass = crypt($password, $salt);
        my(@row) = ();
        # Check username first
        if ( !(&FindRecord('user',"*","username='$username'",\@row )) ) {
           $ovar->{'message'} = "$username $gvar->{'loginmessage1'}";
           &genlib::RtrnPage("$config{'HtmlTemplates'}/$LoginHtml");
           &CloseDBI();
           exit(0);
        }

        # Check password
        if ($row[$cvar->{'PASSWORD'}] ne $cryptpass ) {
           $ovar->{'message'} = $gvar->{'loginmessage2'};
           &CloseDBI();
           &genlib::RtrnPage("$config{'HtmlTemplates'}/$LoginHtml");
           exit;
        }

        # Check Account Activated
        if ( $row[$cvar->{'ACTIVATE'}] != 1) {
           $ovar->{'message'} = $gvar->{'loginmessage4'};
           &CloseDBI();
           &genlib::RtrnPage("$config{'HtmlTemplates'}/$LoginHtml");
           exit;
        }

        # Check expiry date
        # Calculate date in seconds
        if (!$gvar->{'ignore_expirydate'}) {
           my $timedt = &genlib::SqlDtToSec($row[$cvar->{'EXPIRY_DATE'}]);
           my $time_today = time;
           if ( $timedt < $time_today) {
              $ovar->{'message'} = $gvar->{'loginmessage3'};
              &CloseDBI();
              &genlib::RtrnPage("$config{'HtmlTemplates'}/$LoginHtml");
              exit;
           }
        }

        $page = $gvar->{'ResponsePageLogin'};

        if (!$gvar->{'AllowMultipleLogins'}) {
           # Allow only one login - check if logged in.

           # 1. Check if logged if lapsed time greater than N minutes
           # 2. Allow log in if greater than N
           # 3. Disallow log if less than N
           my $timenow = time;
           my $lapseseconds = $gvar->{'SessionTimeInMinutes'} * 60;

           my $sessiontime = 0;
           if ($gvar->{'DatabaseSessionTime'}) {
              $sessiontime = $row[$cvar->{'TIMEIN'}];
           }
           else {
              $sessiontime = &genlib::&GetSessionTime();
           }
           if ( ($timenow - $sessiontime) < $lapseseconds ) {
              # Logged in doing things
              $ovar->{'message'} = $gvar->{'loginmessage5'};
              &CloseDBI();
              &genlib::RtrnPage("$config{'HtmlTemplates'}/$LoginHtml");
              exit;
           }
        }

        # Update session time
        if ($gvar->{'DatabaseSessionTime'} == 1) {
           my @datauser = ();  my %FldType = ();
           $datauser[0] = 'timein';
           $VALUES{'timein'} = time;
           &UpDtData('user', \@datauser, \%VALUES, "username='$username'");
        }
        $QEVar{'LONGDATE'} = 'longdate';
        $QEVar{'LONGTIME'} = 'longtime';
        $QEVar{'FIRSTNAME'} = 'firstname';
        $QEVar{'LASTNAME'} = 'lastname';
        ($ovar->{'firstname'}, $ovar->{'lastname'}) = &GetName($username);
        &CloseDBI();

        # Set session login ticket with session time.
        my $cookie = &genlib::CrtSessionLoginTicket($username);
        print "Set-Cookie: $cookie\n";
     }

}
elsif ($page eq 'update_profile.htm') {
   #######################################
   #     Open DBI Connection
   #######################################
   &SetDBI();

   # Find record of username
   my @row = (); my @fldnames = ();
   if (!&FindRecord('register', "*", "username='$username'", \@row, \@fldnames)) {;
      &genlib::SysSqlError("command.cgi", "User: $username not found register", '', $dbh->err, $dbh->errstr);
      exit;
   }
   else {
      if ($debug) { print "action=3\n"; }
      my($nk) = 0;  my($fld) = '';
      foreach $fld (@fldnames) {
         $ovar->{$fld} = $row[$nk++];
         if ($debug) { print "fld=$fld\n"; }
         if ($debug) { print "fldvl=$ovar->{$fld}\n"; }
      }

      my($var1) = '';
      $var1 = join("_", "slc_state", $ovar->{'state'});
      $ovar->{$var1} = "selected";
      $var1 = join("_", "slc_country", $ovar->{'country'});
      $ovar->{$var1} = "selected";

      $ovar->{'username'} = $username;

      $QEVar{'USERNAME'} = 'username';
      $QEVar{'REGISTERDATE'} = 'registerdate';
      $QEVar{'EXPIRYDATE'} = 'expirydate';
      $QEVar{'FIELDS'} = 'fields';
      @row = ();
      if (!&FindRecord('recovery', "*", "username='$username'", \@row) ) {

         &CloseDBI();
         &genlib::SysSqlError("command.cgi", "User: $username not found in recovery", '', $dbh->err, $dbh->errstr);

      }
      #$ovar->{'cpassword2'} = $ovar->{'cpassword'} = $row[1];
      $ovar->{'reminder'} = $row[2];
   }


   &genlib::OpenParam("$config{'DataPath'}/register.txt", $gvar);
   if (!$gvar->{'ignore_sessiontime'}) {
      my $rtrn_vl = '';
      if ($debug) { print "sessiontime=$sessiontime\n"; }

      ($rtrn_vl, $ovar->{'message'}) =  &genlib::CheckSessionTime($username, $sessiontime);
      if ($rtrn_vl == 0) {
         &genlib::RtrnPage("$config{'HtmlTemplates'}/$gvar->{'LoginHtml1'}");
         &CloseDBI();
         exit(0);
      }

      &genlib::UpDtSessionTime($username);
   }
   &CloseDBI();
}
elsif ($page eq 'terminate_response.htm') {
   #######################################
   #     Open DBI Connection
   #######################################
   &SetDBI();

   # Update user table with log in time
   my @datauser = ();
   $datauser[0] = 'timein';
   $VALUES{'timein'} = 0;  # set to 0 to force log in
   &UpDtData('user', \@datauser, \%VALUES, "username='$username'");

   &CloseDBI();

}
elsif ($page eq 'main_menu.htm') {
   #######################################
   #     Open DBI Connection
   #######################################
   &SetDBI();

   $QEVar{'LONGDATE'} = 'longdate';
   $QEVar{'LONGTIME'} = 'longtime';
   $QEVar{'FIRSTNAME'} = 'firstname';
   $QEVar{'LASTNAME'} = 'lastname';
   ($ovar->{'firstname'}, $ovar->{'lastname'}) = &GetName($username);

   &CloseDBI();

}


&genlib::SetUpTemplates("$config{'HtmlTemplates'}");

if ($debug) { print "$config{'HtmlTemplates'}/$page\n"; }
if ($debug) { print "message=$ovar->{'message'}\n"; }
&genlib::InitializeOut();
&genlib::RdOutFile("$config{'HtmlTemplates'}/$page");

exit;
