#!/usr/bin/perl
# usually active state version
# C:/Perl/bin/perl.exe
# usually a mod_perl version
# C:/Perl/5.6.0/bin/MSWin32-x86/perl.exe
#  application: SQL QuickRegister Password Management System
#       script: findpass.cgi
#      Version: March/2002 1.0
#       author: David Jourard
#               Bytes Interactive
#               http://www.bytesinteractive.com
#               cgi@bytesinteractive.com
# requirements: perl 5 Unix Version and mySQL
#
#
#  description: Find Password
# ***************************************************************************
# SQL QuickRegister
# COPYRIGHT NOTICE
# Copyright 2002 David Jourard  All Rights Reserved.
#
# This program cannot be used till one reads and agrees the terms of the license
# defined in the file license.txt which comes with the software.
#*****************************************************************************
#Clears data if connection is broken
$|= 1;

use strict;
use vars qw($gvar $cvar $ovar %config $debug $dbh %QEVar @othertemplates);
use Time::Local;

$debug=0;
if ($debug) {
   print STDOUT "Content-type: text/plain\n\n";
}


#######################################
#     Call Perl Libraries
#######################################
require "startup_quickregister.pl";
require "genlib.pl";
require "mysqllib.pl";

&genlib::OpenParam("$config{'DataPath'}/config.txt", $gvar);
&genlib::OpenParam("$config{'DataPath'}/messages.txt", $gvar);

&ModifyConfig(\@othertemplates, \%QEVar);

#######################################
#     Open parameter table
#######################################
&genlib::OpenParam("$config{'DataPath'}/register.txt", $gvar);

#######################################
#     Open DBI Connection
#######################################
&SetDBI();

###########################################
#   Prepare date and time for registration
###########################################
&genlib::CreateDate(\$gvar->{'time'},\$ovar->{'longdate'},\$gvar->{'date'},\$gvar->{'shortdate2'}, \$gvar->{'sqldate'}, \$ovar->{'longtime'});



#######################################
#     Read in Form Data
#######################################
my %VALUES = ();
%VALUES = &genlib::ParseData();
my $email = $VALUES{'email'};
$ovar->{'email'} = $email;
$ovar->{'reminder'} = $VALUES{'reminder'};

$VALUES{'reminder'} = &genlib::trim($VALUES{'reminder'});


my($MainPage) = '';  my($ValidateFlds) = '';  my($customcheck1)='';
my($ResponseHtml) = '';
my(@data_var) = ();
$MainPage = $gvar->{'FindPassword'};
$ResponseHtml = $gvar->{'ResponseFindPassword'};
$ValidateFlds = $gvar->{'ValidFldsFindPassword'};
my $table1 = 'register';
my $table2 = 'recovery';

#$customcheck1=1;
&genlib::SetUpTemplates("$config{'HtmlTemplates'}");

#######################################
#      Validate empty fields
#######################################
my($strng);
if ($strng = &genlib::ChkEmptyFields(\%VALUES, $ValidateFlds)) {

   if ($debug) {
      my($key) = '';
      foreach $key (keys %{$ovar}) {
         print " ovar in reg $key = $ovar->{$key}\n";
      }
   }
   $ovar->{'message'}=join('',$gvar->{'registermessage1'}, "<b> $strng.</b>");
   &genlib::RtrnPage("$config{'HtmlTemplates'}/$MainPage");
   exit(0);
}

#######################################
#      Validate e-mail field
#######################################
if ($VALUES{'email'}) {
   my($ValMsg) = '';
   if ( ($ValMsg = &genlib::ValEmail($VALUES{'email'})) ) {
       $ovar->{'message'} = $ValMsg;
       &genlib::RtrnPage("$config{'HtmlTemplates'}/$MainPage");
       exit(0);
   }
}


my(@row) = ();
# Check username first
if ( !(&FindRecord($table1,"username","email='$email'",\@row )) ) {
   $ovar->{'message'} = $gvar->{'findpasswordmessage1'};
   &genlib::RtrnPage("$config{'HtmlTemplates'}/$MainPage");
   &CloseDBI();
   exit(0);
}
my $username = $row[0];


@row = ();
# Check username first
if ( !(&FindRecord($table2,"password, reminder","username='$username'",\@row )) ) {
   $ovar->{'message'} = "$VALUES{'username'} $gvar->{'loginmessage1'}";
   &genlib::RtrnPage("$config{'HtmlTemplates'}/$MainPage");
   &CloseDBI();
   exit(0);
}
my $password = $row[0];
my $reminder = $row[1];


if ($reminder ne $VALUES{'reminder'}) {
   $ovar->{'message'} = $gvar->{'findpasswordmessage2'};
   &genlib::RtrnPage("$config{'HtmlTemplates'}/$MainPage");
   exit(0);
}

&CloseDBI();

$ovar->{'username'} = $username;
$ovar->{'password'} = $password;
$ovar->{'loginURL'} = $gvar->{'loginURL'};

# Send e-mail
# Send to customer

if ($email) {
   if ($gvar->{'MailType'} == 0) {
      &genlib::SendUnixMail($email,
                    $gvar->{'FP_EmailFrom'},
                    $gvar->{'FP_EmailFromAdd'},
                    $gvar->{'FP_EmailSubject'},
                    $gvar->{'FP_EmailCC'},
                    "$config{'HtmlTemplates'}/$gvar->{'FP_EmailTemplate'}"
                   );
   }
   else {
      &genlib::SendSmtpMail($email,
                    $gvar->{'FP_EmailFrom'},
                    $gvar->{'FP_EmailFromAdd'},
                    $gvar->{'FP_EmailSubject'},
                    $gvar->{'FP_EmailCC'},
                    "$config{'HtmlTemplates'}/$gvar->{'FP_EmailTemplate'}"
                   );
   }
}




&genlib::InitializeOut();
&genlib::RdOutFile("$config{'HtmlTemplates'}/$ResponseHtml");
exit(0);

1;
