#!/usr/bin/perl
# usually active state version
# C:/Perl/bin/perl.exe
# usually a mod_perl version
# C:/Perl/5.6.0/bin/MSWin32-x86/perl.exe
#  application: SQL QuickRegister Password Management System
#       script: login.cgi
#      Version: March/2002 1.0
#       author: David Jourard
#               Bytes Interactive
#               http://www.bytesinteractive.com
#               cgi@bytesinteractive.com
# requirements: perl 5 Unix Version and mySQL
#
#
#  description: Login
# ***************************************************************************
# SQL QuickRegister
# COPYRIGHT NOTICE
# Copyright 2002 David Jourard  All Rights Reserved.
#
# This program cannot be used till one reads and agrees the terms of the license
# defined in the file license.txt which comes with the software.
#*****************************************************************************
#Clears data if connection is broken
$|= 1;

use strict;
use vars qw($gvar $cvar $ovar %config $debug $dbh %QEVar @othertemplates);
use Time::Local;
use Digest::MD5;
use CGI::Cookie;

$debug=0;
if ($debug) {
   print STDOUT "Content-type: text/plain\n\n";
}


#######################################
#     Call Perl Libraries
#######################################
require "startup_quickregister.pl";
require "genlib.pl";
require "mysqllib.pl";

&genlib::OpenParam("$config{'DataPath'}/config.txt", $gvar);
&genlib::OpenParam("$config{'DataPath'}/messages.txt", $gvar);

&ModifyConfig(\@othertemplates, \%QEVar);


#######################################
#     Open parameter table
#######################################
&genlib::OpenParam("$config{'DataPath'}/register.txt", $gvar);

#######################################
#     Open DBI Connection
#######################################
&SetDBI();

###########################################
#   Prepare date and time for registration
###########################################
&genlib::CreateDate(\$gvar->{'time'},\$gvar->{'longdate'},\$gvar->{'date'},\$gvar->{'shortdate2'}, \$gvar->{'sqldate'}, \$gvar->{'longtime'});


#######################################
#     Read in Form Data
#######################################
my %aCookies = &genlib::GetCookies();


my %VALUES = ();
%VALUES = &genlib::ParseData();
&genlib::SetUpTemplates("$config{'HtmlTemplates'}");

$ovar->{'username'} = $VALUES{'username'};

my($LoginHtml) = '';  my($ValidateFlds) = '';  my($customcheck1)='';
my($login_table) = '';
my($ResponseHtml) = '';
my(@data_var) = ();
$LoginHtml = $gvar->{'LoginHtml1'};
$ResponseHtml = $gvar->{'ResponsePageLogin'};
$ValidateFlds = $gvar->{'ValidFldsLogin'};
$login_table = 'user';

#?(@data_var) = split(/:/,$gvar->{'Data_Buyer'});

$customcheck1=1;

#######################################
#      Validate empty fields
#######################################
my($strng);
if ($strng = &genlib::ChkEmptyFields(\%VALUES, $ValidateFlds)) {

   if ($debug) {
      my($key) = '';
      foreach $key (keys %{$ovar}) {
         print " ovar in reg $key = $ovar->{$key}\n";
      }
   }
   $ovar->{'message'}=join('',$gvar->{'registermessage1'}, "<b> $strng.</b>");
   &genlib::RtrnPage("$config{'HtmlTemplates'}/$LoginHtml");
   exit(0);
}



my($username)=''; my($password)=''; my($salt)=''; my($cryptpass)='';
$VALUES{'username'} =~ s/\s*//g;
$VALUES{'password'} =~ s/\s*//g;
$username = $VALUES{'username'};
$password = $VALUES{'password'};


$salt = substr($password,0,2);
$cryptpass = crypt($password, $salt);

if ($debug) { print " cryptpass=$cryptpass .....\n";}
if ($debug) { print " password=$password .....\n";}


my(@row) = ();
# Check username first
if ( !(&FindRecord($login_table,"*","username='$username'",\@row )) ) {
   $ovar->{'message'} = "$VALUES{'username'} $gvar->{'loginmessage1'}";
   &genlib::RtrnPage("$config{'HtmlTemplates'}/$LoginHtml");
   exit(0);
}


# Check password
if ($row[$cvar->{'PASSWORD'}] ne $cryptpass ) {
   $ovar->{'message'} = $gvar->{'loginmessage2'};
   &genlib::RtrnPage("$config{'HtmlTemplates'}/$LoginHtml");
   exit;
}

# Check Account Activated
if ( $row[$cvar->{'ACTIVATE'}] != 1) {
   $ovar->{'message'} = $gvar->{'loginmessage4'};
   &genlib::RtrnPage("$config{'HtmlTemplates'}/$LoginHtml");
   exit;
}

# Check expiry date
# Calculate date in seconds
if (!$gvar->{'ignore_expirydate'}) {
   my $testdt = &genlib::SqlDtToSec($row[$cvar->{'EXPIRY_DATE'}]);
   my $testtod = time;
   if ($debug) { print "timeexpiry=$testdt\n"; }
   if ($debug) { print "timetoday=$testtod\n"; }
   if ( &genlib::SqlDtToSec($row[$cvar->{'EXPIRY_DATE'}]) < time) {
      $ovar->{'message'} = $gvar->{'loginmessage3'};
      &genlib::RtrnPage("$config{'HtmlTemplates'}/$LoginHtml");
      exit;
   }
}

# Update access log to application -
if ($debug) { print "access log ....\n"; }
#pen(PDT, ">>$config{'DataPath'}/login/accesslog.txt") ||  &genlib::SysError('login.cgi', 'Cannot open accesslog.txt');
#print PDT "$username:$gvar->{'date'}:$gvar->{'time'}:$ENV{'REMOTE_HOST'}\n";
#close(PDT);


if (!$gvar->{'AllowMultipleLogins'}) {
   # Allow only one login - check if logged in.

   # 1. Check if logged if lapsed time greater than N minutes
   # 2. Allow log in if greater than N
   # 3. Disallow log if less than N
   my $timenow = time;
   my $lapseseconds = $gvar->{'SessionTimeInMinutes'} * 60;

   if ( ($timenow - $row[$cvar->{'TIMEIN'}]) < $lapseseconds ) {
      # Logged in doing things
      $ovar->{'message'} = $gvar->{'loginmessage5'};
      &genlib::RtrnPage("$config{'HtmlTemplates'}/$LoginHtml");
      exit;
   }
}


# Update user table with log in time
my @datauser = ();  my %FldType = ();
$datauser[0] = 'timein';
$VALUES{'timein'} = time;
&UpDtData('user', \@datauser, \%VALUES, "username='$username'");


$QEVar{'LONGDATE'} = 'longdate';
$QEVar{'LONGTIME'} = 'longtime';
$ovar->{'longdate'} =$gvar->{'longdate'};
$ovar->{'longtime'} =$gvar->{'longtime'};
$QEVar{'FIRSTNAME'} = 'firstname';
$QEVar{'LASTNAME'} = 'lastname';
($ovar->{'firstname'}, $ovar->{'lastname'}) = &GetName($username);

&CloseDBI();


# Create auto login and session login ticket
my $cookie = '';
if ($gvar->{'UseAutoLogin'} == 1) {
   $cookie = &CrtAutoLoginTicket($username, $password);
   # Create cookie with ticket
   print "Set-Cookie: $cookie\n";
}

$cookie = &genlib::CrtSessionLoginTicket($username);
print "Set-Cookie: $cookie\n";

if ($debug) { print "cookie=$cookie\n"; }

#print "Set-Cookie:$cookie\n";

#&genlib::SetUpTemplates("$config{'HtmlTemplates'}");
$ovar->{'username'} = $username;
&genlib::InitializeOut();
&genlib::RdOutFile("$config{'HtmlTemplates'}/$ResponseHtml");
exit(0);



sub CrtAutoLoginTicket {
   my($user) = $_[0];
   my($password) = $_[1];

   if ($debug) { print "hello\n"; }


                         # -domain=>"$gvar->{'domainname'}",
   return CGI::Cookie->new(-name=>'Ticket',
                           -expires=>"$gvar->{'cookie_expires_in'}",
                           -path=>'/',
                           -value =>{ 'who' => $user,
                                      'how' => $password,
                                    }
                           );


}
