#!/usr/bin/perl
# usually active state version
# C:/Perl/bin/perl.exe
# usually a mod_perl version
#!C:/Perl/5.6.0/bin/MSWin32-x86/perl.exe
#  application: SQL QuickRegister Password Management System
#       script: mktable.cgi
#      Version: May/2001 1.0
#       author: David Jourard
#               Bytes Interactive
#               http://www.bytesinteractive.com
#               cgi@bytesinteractive.com
# requirements: perl 5 Unix Version and mySQL
#
#
#  description: Creates SQL tables
# ***************************************************************************
# SQL QuickRegister
# COPYRIGHT NOTICE
# Copyright 2002 David Jourard  All Rights Reserved.
#
# This program cannot be used till one reads and agrees the terms of the license
# defined in the file license.txt which comes with the software.
#*****************************************************************************
#Clears data if connection is broken
$|= 1;

use strict;
use CGI::Carp;
use vars qw($gvar $cvar $ovar %config $debug $dbh %QEVar %c);

$debug=0;
if ($debug) {
   print STDOUT "Content-type: text/plain\n\n";
}

#######################################
#     Call Perl Libraries
#######################################
require "startup_quickregister.pl";
require "genlib.pl";
require "mysqllib.pl";

#######################################
#     Open DBI Connection
#######################################
&SetDBI();

&genlib::InitializeOut();
&genlib::RdOutFile("$config{'HtmlTemplates'}/mktable_header.htm");

my($prepare) = ''; my($rows) = '';
# Indicies
my $register_index1 = "username";
my $register_index2 = "email";
my $user_index1 = "username";
my $recovery_index1 = "username";

my($drop_register) = 0;
$prepare = "SELECT count(*) FROM register";
$rows = $dbh->do( $prepare );
if ($rows) {
   $drop_register = 1;
}


my($drop_user) = 0;
$prepare = "SELECT count(*) FROM user";
$rows = $dbh->do( $prepare );
if ($rows) {
   $drop_user = 1;
}
my($drop_recovery) = 0;
$prepare = "SELECT count(*) FROM recovery";
$rows = $dbh->do( $prepare );
if ($rows) {
   $drop_recovery = 1;
}

my $registertable = 1;
my $usertable = 1;
my $recoverytable = 1;

# Create  registration table and indices
if ($registertable) {
   if ($drop_register) {

      print STDOUT "Deleting $register_index1 index ...<br>\n";
      $prepare = "ALTER TABLE register DROP INDEX $register_index1";
      $rows = $dbh->do( $prepare );

      print STDOUT "Deleting $register_index2 index ...<br>\n";
      $prepare = "ALTER TABLE register DROP INDEX $register_index2";
      $rows = $dbh->do( $prepare );

      if ($debug) {print "Deleting  registration table...<br>\n";}
      print STDOUT "Deleting  registration table...<br>\n";
      $rows = $dbh->do( "drop table register");

      if (!$rows) { &genlib::SysSqlError('mktable.cgi','Cannot drop  register','', $dbh->err, $dbh->errstr); }

   }

   print STDOUT "<br><br>\n";

   if ($debug) {print "Creating  registration table...\n";}
   print STDOUT "Creating  registration table...<br>\n";
   $rows = $dbh->do( "CREATE TABLE register (
                        username     varchar(20) not null,
                        email        varchar(100),
                        lastname     varchar(40),
                        firstname    varchar(25),
                        company      varchar(100),
                        address1     varchar(40),
                        address2     varchar(40),
                        city         varchar(40),
                        state        varchar(40),
                        state2       varchar(40),
                        zip          varchar(10),
                        country      varchar(60),
                        instantmsgid varchar(100),
                        phone        varchar(20),
                        cell         varchar(20),
                        fax          varchar(20),
                        registerdate date,
                        updatedate   date,
                        activatedate date,
                        expirydate   date )");

      if (!$rows) { &genlib::SysSqlError('mktable.cgi', 'Cannot create  register', '', $dbh->err, $dbh->errstr); }

   print STDOUT "Indexing $register_index1 on username ...<br>\n\n";
   $prepare = "ALTER TABLE register ADD PRIMARY KEY $register_index1 (username)";
   $rows = $dbh->do( $prepare );

   print STDOUT "Indexing $register_index1 on email ...<br>\n\n";
   $prepare = "ALTER TABLE register ADD INDEX $register_index2 (email)";
   $rows = $dbh->do( $prepare );


}


if ($usertable) {
   if ($drop_user) {

      print STDOUT "<br><br>\n";

      print STDOUT "Deleting $user_index1 index ...<br>\n";
      $prepare = "ALTER TABLE user DROP INDEX $user_index1";
      $rows = $dbh->do( $prepare );

      if ($debug) {print "Deleting user table...\n";}
      print STDOUT "Deleting user table...<br>\n";
      $rows = $dbh->do( "drop table user");

      if (!$rows) { &genlib::SysSqlError('mktable.cgi', 'Cannot drop user_seller',  '', $dbh->err, $dbh->errstr); }

   }

   print STDOUT "<br><br>\n";

   if ($debug) {print "Creating table user_...\n";}
   print STDOUT "Creating user_ table...<br>\n";
   $rows = $dbh->do( "CREATE TABLE user (
                         username    varchar(20) not null,
                         password    varchar(20),
                         expirydate  date,
                         timein      varchar(20),
                         activate    smallint )");


   if (!$rows) { &genlib::SysSqlError('mktable.cgi', 'Cannot create user', '', $dbh->err, $dbh->errstr); }

   print STDOUT "Indexing $user_index1 on username ...<br>\n\n";
   $prepare = "ALTER TABLE user ADD PRIMARY KEY $user_index1 (username)";
   $rows = $dbh->do( $prepare );
}


if ($recoverytable) {
   if ($drop_recovery) {
      print STDOUT "<br><br>\n";

      print STDOUT "Deleting $recovery_index1 index ...<br>\n";
      $prepare = "ALTER TABLE recovery DROP INDEX $recovery_index1";
      $rows = $dbh->do( $prepare );

      if ($debug) {print "Deleting recovery table...\n";}
      print STDOUT "Deleting recovery table...<br>\n";
      $rows = $dbh->do( "drop table recovery");

      if (!$rows) { &genlib::SysSqlError('mktable.cgi', 'Cannot drop recoveryseller', '', $dbh->err, $dbh->errstr); }

   }

   print STDOUT "<br><br>\n";
   if ($debug) {print "Creating table recovery...\n";}
   print STDOUT "Creating recovery table...<br>\n";
   $rows = $dbh->do( "CREATE TABLE recovery (
                         username    varchar(20) not null,
                         password    varchar(20),
                         reminder    varchar(40) )");


   if (!$rows) { &genlib::SysSqlError('mktable.cgi', 'Cannot create recoveryseller','', $dbh->err, $dbh->errstr); }

   print STDOUT "Indexing $recovery_index1 on username ...<br>\n\n";
   $prepare = "ALTER TABLE recovery ADD PRIMARY KEY $recovery_index1 (username)";
   $rows = $dbh->do( $prepare );

}


&CloseDBI();

&genlib::RdOutFile("$config{'HtmlTemplates'}/mktable_footer.htm");

exit;



1;
