#!/usr/bin/perl
#  application: SQL QuickRegister Password Management System
#       script: mysqllib.pl
#      Version: March/2002 1.0
#       author: David Jourard
#               Bytes Interactive
#               http://www.bytesinteractive.com
#               cgi@bytesinteractive.com
# requirements: perl 5 Unix Version and mySQL
#
#
#  description: general mysql functions
# ***************************************************************************
# SQL QuickRegister
# COPYRIGHT NOTICE
# Copyright 2002 David Jourard  All Rights Reserved.
#
# This program cannot be used till one reads and agrees the terms of the license
# defined in the file license.txt which comes with the software.
#*****************************************************************************

use strict;
use vars qw($gvar $cvar $ovar %config $debug $dbh %QEVar);

sub SetDBI {

 # Set error parmeters to zero - we control error messaging
 my (%attr) = ( PrintError => 0, RaiseError => 0 );

 use DBI;
 $dbh = DBI->connect("DBI:mysql:$config{'database'}:$config{'server'}", $config{'username'}, $config{'password'}, \%attr) ||  &genlib::SysSqlError("mktable\.cgi", "Cannot connect to database",'',$DBI::err,$DBI::errstr);

}


sub CloseDBI {
   $dbh->disconnect;
}

sub Appnd {
   my($dtfile) = $_[0];
   my($ra_fldlist) = $_[1];
   my($rh_VALUES) = $_[2];
   my($fieldstring) = '';

   my($ni) = 0; my($fld) = ''; my($var) = ''; my($SqlCmd)= '', my($rows) = '';

   $ni=0;
   foreach $fld (@{$ra_fldlist}) {

      $$rh_VALUES{$fld} =~ s/'/\\'/g;
      $$rh_VALUES{$fld} =~ s/"/\\"/g;

      if ($ni == $#{$ra_fldlist}) {
         $fieldstring = join("", $fieldstring, "'$$rh_VALUES{$fld}'");
      }
      else {
         $fieldstring = join("", $fieldstring, "'$$rh_VALUES{$fld}',");
      }

      $ni++;
   }
   if ($debug) { print "sqltable=$dtfile\n"; }
   if ($debug) { print "fieldlist=$fieldstring\n"; }
   $SqlCmd = "insert into $dtfile values ($fieldstring)";
   if ($debug) { print "sqlcmd=$SqlCmd\n"; }

   $rows = $dbh->do( $SqlCmd );
   if ($debug) { print "rows=$rows\n"; }
   if (!$rows) {
      &genlib::SysSqlError("Appnd", "Cannot add record to $dtfile", $SqlCmd,
$dbh->err, $dbh->errstr);
   }

   return($rows);
}

sub Appndm {
   my($dtfile) = $_[0];
   my($ra_fldlist) = $_[1];
   my($rh_VALUES) = $_[2];
   my($rh_FldTypes) = $_[3];
   my($fieldstring) = '';

   my($ni) = 0; my($fld) = ''; my($var) = ''; my($SqlCmd)= '', my($rows) = '';

   $ni=0;
   foreach $fld (@{$ra_fldlist}) {

      $$rh_VALUES{$fld} =~ s/'/\\'/g;
      $$rh_VALUES{$fld} =~ s/"/\\"/g;

      if ($ni == $#{$ra_fldlist}) {
         if ($$rh_FldTypes{$fld} eq 'N') {
            if ( !defined($$rh_VALUES{$fld}) ) {
               $fieldstring = join("", $fieldstring, "-1,");
            }
            elsif (!$$rh_VALUES{$fld}) {
               $fieldstring = join("", $fieldstring, "0");
            }
            else {
               $fieldstring = join("", $fieldstring, "$$rh_VALUES{$fld}");
            }
         }
         else {
            $fieldstring = join("", $fieldstring, "'$$rh_VALUES{$fld}'");
         }
      }
      else {
         if ($$rh_FldTypes{$fld} eq 'N') {
            if ( !defined($$rh_VALUES{$fld}) ) {
               $fieldstring = join("", $fieldstring, "-1,");
            }
            elsif (!$$rh_VALUES{$fld}) {
               $fieldstring = join("", $fieldstring, "0,");
            }
            else {
               $fieldstring = join("", $fieldstring, "$$rh_VALUES{$fld},");
            }
         }
         else {
            $fieldstring = join("", $fieldstring, "'$$rh_VALUES{$fld}',");
         }
      }

      $ni++;
   }
   if ($debug) { print "sqltable=$dtfile\n"; }
   if ($debug) { print "fieldlist=$fieldstring\n"; }
   $SqlCmd = "insert into $dtfile values ($fieldstring)";
   if ($debug) { print "sqlcmd=$SqlCmd\n"; }

   $rows = $dbh->do( $SqlCmd );
   if ($debug) { print "error=$dbh->errstr\n"; }
   if ($debug) { print "rows=$rows\n"; }
   if (!$rows) {
      &genlib::SysSqlError("Appnd", "Cannot add record to $dtfile", $SqlCmd,
$dbh->err, $dbh->errstr);
   }

   return($rows);
}

sub FindRecord {
  my($sqltable) = $_[0];
  my($fieldlist) = $_[1];
  my($searchfor) = $_[2];
  my($ra_row)    = $_[3];
  my($ra_fldnames) = $_[4];
  my($SqlCmd)='';  my($rc)='';
  my($rtrn_vl) = 0;

  if ($debug) { print "FindRecord() ...\n"; }

   if ($debug) { print "   sqltable=$sqltable\n"; }
   if ($debug) { print "   fieldlist=$fieldlist\n"; }
   if ($debug) { print "   searchfor=$searchfor\n"; }


   # Exact Search
   $SqlCmd = "SELECT $fieldlist FROM $sqltable where $searchfor";

   if ($debug) { print "   Sqlcmd=$SqlCmd\n"; }

   my $sth = $dbh->prepare( $SqlCmd );

   if (!$sth) {
      &genlib::SysSqlError("FindRecord","prepare failed", $SqlCmd,$dbh->err,$dbh->errstr);
   }
   $rc = $sth->execute();

   if ($debug) { print "rc=$rc\n"; }


   if (!$rc) {
      # Undefined
      &genlib::SysSqlError("FindRecord","execute failed",$SqlCmd,$dbh->err,$dbh->errstr);
   }
   elsif ($rc eq '0E0') {
      $rtrn_vl = 0;
   }
   elsif ($rc eq '1') {
      @{$ra_row} = $sth->fetchrow;

      my $name = $sth->{NAME};

      my($nk) = 0;  my($nm) = '';
      foreach $nm (@{$name}) {
         $$ra_fldnames[$nk++] = $nm
      }

      $rtrn_vl = 1;
   }
   else {
      &genlib::SysSqlError("FindRecord", "Username duplicated in data table",
$SqlCmd,$dbh->err,$dbh->errstr);
   }


   $sth->finish;

   if ($debug) { print "end_of_FindKey() ...\n"; }

   return $rtrn_vl;
}

sub UpDtData {
  my($sqltable) = $_[0];
  my($ra_fldlist) = $_[1];
  my($rh_VALUES) = $_[2];
  my($searchfor) = $_[3];
  my($fieldstring) = '';
  my($lRtrn) = 0;

   if ($debug) { print "UpDtData() ...\n"; }
   if ($debug) { print "   sqltable=$sqltable\n"; }

   #if ($debug) { print "   sqltable=$sqltable\n"; }
   #if ($debug) { print "   fieldlist=$fieldlist\n"; }
   #if ($debug) { print "   searchfor=$searchfor\n"; }

   my($fld) = ''; my($ni) = 0;

   foreach $fld (@{$ra_fldlist}) {

      $$rh_VALUES{$fld} =~ s/'/\\'/g;
      $$rh_VALUES{$fld} =~ s/"/\\"/g;

      if ($ni == $#{$ra_fldlist}) {
         $fieldstring = join("", $fieldstring, "$fld='$$rh_VALUES{$fld}'");
      }
      else {
         $fieldstring = join("", $fieldstring, "$fld='$$rh_VALUES{$fld}',");
      }

      $ni++;
   }

   # Exact Search

   my $SqlCmd = "UPDATE $sqltable SET $fieldstring WHERE $searchfor";
   if ($debug) { print "   Sqlcmd=$SqlCmd\n"; }
   my $rows = $dbh->do( $SqlCmd );

   if (!$rows) { &genlib::SysSqlError('registerlib.pl - updtdata',"Cannot update $sqltable", '', $dbh->err, $dbh->errstr); }


   if ($debug) { print "end of UpDtData() ...\n"; }
   return;
}

sub UpDtm {
   my($dtfile) = $_[0];
   my($ra_fldlist) = $_[1];
   my($rh_VALUES) = $_[2];
   my($rh_FldTypes) = $_[3];
   my($searchfor) = $_[4];
   my($fieldstring) = '';

   my($ni) = 0; my($fld) = ''; my($var) = ''; my($SqlCmd)= '', my($rows) = '';

   $ni=0;
   foreach $fld (@{$ra_fldlist}) {

      $$rh_VALUES{$fld} =~ s/'/\\'/g;
      $$rh_VALUES{$fld} =~ s/"/\\"/g;

      if ($ni == $#{$ra_fldlist}) {
         if ($$rh_FldTypes{$fld} eq 'N') {
            if ( !defined($$rh_VALUES{$fld}) ) {
               $fieldstring = join("", $fieldstring, "$fld=-1");
            }
            elsif (!$$rh_VALUES{$fld}) {
               $fieldstring = join("", $fieldstring, "$fld=0");
            }
            else {
               $fieldstring = join("", $fieldstring, "$fld=$$rh_VALUES{$fld}");
            }
         }
         else {
            $fieldstring = join("", $fieldstring, "$fld='$$rh_VALUES{$fld}'");
         }
      }
      else {
         if ($$rh_FldTypes{$fld} eq 'N') {
            if ( !defined($$rh_VALUES{$fld}) ) {
               $fieldstring = join("", $fieldstring, "$fld=-1,");
            }
            elsif (!$$rh_VALUES{$fld}) {
               $fieldstring = join("", $fieldstring, "$fld=0,");
            }
            else {
               $fieldstring = join("", $fieldstring, "$fld=$$rh_VALUES{$fld},");
            }
         }
         else {
            $fieldstring = join("", $fieldstring, "$fld='$$rh_VALUES{$fld}',");
         }
      }

      $ni++;
   }
   if ($debug) { print "sqltable=$dtfile\n"; }
   if ($debug) { print "fieldlist=$fieldstring\n"; }
   $SqlCmd = "UPDATE $dtfile SET $fieldstring WHERE $searchfor";
   if ($debug) { print "sqlcmd=$SqlCmd\n"; }

   $rows = $dbh->do( $SqlCmd );
   if ($debug) { print "rows=$rows\n"; }
   if (!$rows) {
      &genlib::SysSqlError("UpDtm", "Cannot add record to $dtfile", $SqlCmd,
$dbh->err, $dbh->errstr);
   }

   return($rows);
}

sub DelRecord {
  my($sqltable) = $_[0];
  my($searchfor) = $_[1];
  my($fieldstring) = '';
  my($lRtrn) = 0;

   if ($debug) { print "DelRecord() ...\n"; }
   if ($debug) { print "   sqltable=$sqltable\n"; }
   if ($debug) { print "   searchfor=$searchfor\n"; }

   my($fld) = ''; my($ni) = 0;


   my $SqlCmd = "DELETE FROM $sqltable WHERE $searchfor";
   if ($debug) { print "   Sqlcmd=$SqlCmd\n"; }
   my $rows = $dbh->do( $SqlCmd );
   if ($debug) { print "rows=$rows\n"; }

   if (!$rows) { &genlib::SysSqlError('registerlib.pl - delrecord', "Cannot delete record from $sqltable", '', $dbh->err, $dbh->errstr); }


   if ($debug) { print "end of DelRecord() ...\n"; }
   return;
}


sub UpDtUsersTable {
  my($letter) = $_[0];


  my($SqlCmd)='';  my($rc)='';  my($rtrn_vl) = 0;

  my($sqltable) = 'register';
  my($fieldlist) = 'cregid';
  my($searchfor) = '';
  my($OrderBy) = '';

  my $editword = 'Edit';
  my $deleteword = 'Delete';

  my $delete = '';
  my $edit = '';

  if ($debug) { print "UsersTable() ...\n"; }

   if ($debug) { print "   sqltable=$sqltable\n"; }
   if ($debug) { print "   fieldlist=$fieldlist\n"; }
   if ($debug) { print "   searchfor=$searchfor\n"; }

   $fieldlist = 'register.lastname, register.firstname, register.username';
   $sqltable = 'register';

   if ($letter eq 'All') {
      $searchfor = '';
   }
   else {
      $searchfor = qq(register.lastname LIKE '$letter%');
   }
   $OrderBy = 'register.lastname, register.firstname';


   if ($debug) { print "   sqltable=$sqltable\n"; }
   if ($debug) { print "   fieldlist=$fieldlist\n"; }
   if ($debug) { print "   searchfor=$searchfor\n"; }


   # Exact Search
   if ($searchfor) {
      $SqlCmd = "SELECT $fieldlist FROM $sqltable WHERE $searchfor ORDER BY $OrderBy";
   }
   else {
      $SqlCmd = "SELECT $fieldlist FROM $sqltable ORDER BY $OrderBy";
   }
   if ($debug) { print "   Sqlcmd=$SqlCmd\n"; }

   my $sth = $dbh->prepare( $SqlCmd );
   $sth->{'mysql_use_result'}=1;  ###*** VERY IMPORTANT ***###
                                 # Set to 1 doesn't store entire result set

   if (!$sth) {
      &CloseDBI();
      &genlib::SysSqlError("admin_clients.cgi", "", $SqlCmd, $dbh->err, $dbh->errstr);
   }
   $rc = $sth->execute();

   if ($debug) { print "rc=$rc\n"; }


   if (!$rc) {
      # Undefined
      &CloseDBI();
      &genlib::SysSqlError("admin_clients.cgi", "", $SqlCmd, $dbh->err, $dbh->errstr);
   }
   elsif ($rc eq '0E0') {
      $rtrn_vl = 0;
   }
   elsif ($rc eq '1') {
      $rtrn_vl = 1;
   }



   # Print out list by header and footer method
   &genlib::InitializeOut();
   &genlib::RdOutFile("$config{'HtmlTemplates'}/admin_clients_header.htm");

   my($LNAME) = 0;
   my($FNAME) = 1;
   my($USERID) = 2;

   my(@row) = (); my($quizname) = ''; my($name) = ''; my($quizlink) = '';
   my($oldname) = '';

   while( @row = $sth->fetchrow_array) {
      if ($debug) {
         my($nh, $fld);
         $nh=0;
         for $fld (@row) {
             print "$nh - fld=$fld\n";
             $nh++;
         }
         print "\n\n********\n";
      }

      $name = join('', $row[$LNAME], ", $row[$FNAME]", " - $row[$USERID]");
      $edit = qq(<a href="/cgi-bin/quickregister/scripts/admin_command.cgi?action=2&username=$row[$USERID]&letter=$letter"> $editword </a>);
      $delete=qq(<a href="/cgi-bin/quickregister/scripts/admin_delete.cgi?action=1&username=$row[$USERID]&letter=$letter"> $deleteword </a>);
      print STDOUT qq(<tr><td> $name </td>);
      print STDOUT qq(<td align="center"> $edit </td>);
      print STDOUT qq(<td align="center"> $delete </td> </tr>);
   }
   $sth->finish;

   # last one
   print STDOUT "</table>\n";

   &genlib::RdOutFile("$config{'HtmlTemplates'}/admin_clients_footer.htm");

   return $rtrn_vl;
}


sub GetName {
   my $username = $_[0];

   # last thing get the first and last name for display
   my @row = ();
   # Check username first
   if ( !(&FindRecord('register',"*","username='$username'",\@row )) ) {
      $ovar->{'message'} = "$username $gvar->{'loginmessage1'}";
      &genlib::RtrnPage("$config{'HtmlTemplates'}/login_error.htm");
      exit(0);
   }

   &genlib::OpenParam("$config{'DataPath'}/register_fields.txt", $cvar);
   my $firstname = $row[$cvar->{'firstname'}-1];
   my $lastname = $row[$cvar->{'lastname'}-1];

   return ($firstname, $lastname);

}

return 1;

