#!/usr/bin/perl
# usually active state version
# C:/Perl/bin/perl.exe
# usually a mod_perl version
# C:/Perl/5.6.0/bin/MSWin32-x86/perl.exe
#  application: SQL QuickRegister Password Management System
#       script: redirect.cgi
#      Version: March/2002
#       author: David Jourard
#               Bytes Interactive
#               http://www.bytesinteractive.com
#               cgi@bytesinteractive.com
# requirements: perl 5 Unix Version and mySQL
#
# modifications: 10/03/02
#                - now allows dynamically create web pages by putting them
#                  in /cgi-bin/templates/mypages and listed in redirect.txt
#
#  description: Control Page for dynamic page creation in admin area
# ***************************************************************************
# SQL QuickRegister
# COPYRIGHT NOTICE
# Copyright 2002 David Jourard  All Rights Reserved.
#
# This program cannot be used till one reads and agrees the terms of the license
# defined in the file license.txt which comes with the software.
#*****************************************************************************
#Clears data if connection is broken
$|= 1;

use strict;
use vars qw($gvar $cvar $ovar %config $debug $dbh %QEVar @othertemplates);
use Time::Local;
#use MD5 ();
use CGI::Cookie;

$debug=0;
if ($debug) {
   print STDOUT "Content-type: text/plain\n\n";
}

#######################################
#     Call Perl Libraries
#######################################
require "startup_quickregister.pl";
require "genlib.pl";
require "mysqllib.pl";

&genlib::OpenParam("$config{'DataPath'}/config.txt", $gvar);
&genlib::OpenParam("$config{'DataPath'}/messages.txt", $gvar);

&ModifyConfig(\@othertemplates, \%QEVar);

my $redirects = {};

&genlib::OpenParam("$config{'DataPath'}/redirect.txt", $redirects);
&genlib::OpenParam("$config{'DataPath'}/register.txt", $gvar);
my $LoginHtml = $gvar->{'LoginHtml1'};

#if ($debug) {
#   my $key='';
#   foreach $key (keys %{$redirects}) {
#      print "$key=$redirects->{$key}\n";
#
#   }
#}
   if ($debug) { print "redirectvl2 = $redirects->{'Welcome'}\n"; }

my %VALUES = &genlib::ParseData();


my %aCookies = &genlib::GetCookies();

if ($debug) { print "tick_type1=$aCookies{'Ticket'}\n"; }


my $redirectURL = '';   my $page = '';

if ($aCookies{'SessionTicket'}) {
   my @row = ();
   my $sessiontime = 0;
   #######################################
   #     Verify Login Ticket
   #######################################
   my ($result) = ''; my($message) = '';  my $username = '';
   ($result, $message, $username, $sessiontime) = &genlib::VerifyLoginTicket();
   if (!$result) {
      #-$page='login_error.htm';
      $ovar->{'message'} = $message;
      &genlib::RtrnPage("$config{'HtmlTemplates'}/$LoginHtml");
      exit;
   }

   if ($debug) { print "username=$username\n"; }

   #######################################
   #     Open DBI Connection
   #######################################
   &SetDBI();
   if ($gvar->{'DatabaseSessionTime'}) {
      if ( !(&FindRecord('user',"*","username='$username'",\@row )) ) {
         $ovar->{'message'} = "$username $gvar->{'loginmessage1'}";
         &genlib::RtrnPage("$config{'HtmlTemplates'}/$LoginHtml");
         &CloseDBI();
         exit(0);
      }
      $sessiontime = $row[$cvar->{'TIMEIN'}];
   }

   if ($sessiontime > 0 && !$gvar->{'ignore_sessiontime'}) {
      # checked lapsed time
      my $timenow = time;
      my $lapseseconds = $gvar->{'SessionTimeInMinutes'} * 60;

      if ( ($timenow - $sessiontime) > $lapseseconds ) {
         # Logged in doing things
         $ovar->{'message'} = $gvar->{'loginmessage6'};
         &CloseDBI();
         &genlib::RtrnPage("$config{'HtmlTemplates'}/$LoginHtml");
         exit;
      }
   }

   if ($gvar->{'DatabaseSessionTime'}) {
      # Update user table with log in time
      my @datauser = ();  my %FldType = ();
      $datauser[0] = 'timein';
      $VALUES{'timein'} = time;
      &UpDtData('user', \@datauser, \%VALUES, "username='$username'");
   }
   else {
      # Update session time via the login cookie
      my $cookie = &genlib::CrtSessionLoginTicket($username);
      print "Set-Cookie: $cookie\n";
   }
   &CloseDBI();

   if ($debug) { print "redirectvl = $VALUES{'redirect'}\n"; }
   if ($debug) { print "redirectvl2 = $redirects->{'Welcome'}\n"; }


   $redirectURL = $redirects->{$VALUES{'redirect'}};
   if ($debug) { print "redirecturl = $redirectURL\n"; }
}
else {

   if ($debug) { print "cookie does not exists\n"; }

   $page = $gvar->{'RedirectErrorPage'};
}


if ($redirectURL) {

   if ($redirectURL =~ /http/) {
      # relocation
      my $next = join("", "Location: ", $redirectURL," \n\n");
      print STDOUT $next;

   }
   else {
      # creating a page from mypages
      my $folder = qq($config{'HtmlTemplates'}/mypages);
      $page = $redirectURL;

      &genlib::SetUpTemplates("$config{'HtmlTemplates'}");

      &genlib::InitializeOut();
      &genlib::RdOutFile("$folder/$page");
   }
}
else {
   # for error page

   &genlib::SetUpTemplates("$config{'HtmlTemplates'}");

   &genlib::InitializeOut();
   &genlib::RdOutFile("$config{'HtmlTemplates'}/$page");
}

exit;
