#!/usr/bin/perl
# usually active state version
# C:/Perl/bin/perl.exe
# usually a mod_perl version
# C:/Perl/5.6.0/bin/MSWin32-x86/perl.exe
#  application: SQL QuickRegister Password Management System
#       script: register.cgi
#      Version: March/2002 1.0
#       author: David Jourard
#               Bytes Interactive
#               http://www.bytesinteractive.com
#               cgi@bytesinteractive.com
# requirements: perl 5 Unix Version and mySQL
#
#
#  description: Register
# ***************************************************************************
# SQL QuickRegister
# COPYRIGHT NOTICE
# Copyright 2002 David Jourard  All Rights Reserved.
#
# This program cannot be used till one reads and agrees the terms of the license
# defined in the file license.txt which comes with the software.
#*****************************************************************************
#Clears data if connection is broken
$|= 1;

use strict;
use vars qw($gvar $cvar $ovar %config $debug $dbh %QEVar @othertemplates);
use Time::Local;
use CGI::Cookie;

$debug=0;
if ($debug) {
   print STDOUT "Content-type: text/plain\n\n";
}

#######################################
#     Call Perl Libraries
#######################################
require "startup_quickregister.pl";
require "genlib.pl";
require "mysqllib.pl";

#######################################
#     Open parameter table
#######################################
&genlib::OpenParam("$config{'DataPath'}/config.txt", $gvar);
&genlib::OpenParam("$config{'DataPath'}/messages.txt", $gvar);

&ModifyConfig(\@othertemplates, \%QEVar);

&genlib::OpenParam("$config{'DataPath'}/register.txt", $gvar);

#######################################
#     Open DBI Connection
#######################################
&SetDBI();

###########################################
#   Prepare date and time for registration
###########################################
&genlib::CreateDate(\$gvar->{'time'},\$ovar->{'longdate'},\$gvar->{'date'},\$gvar->{'shortdate2'}, \$gvar->{'sqldate'}, \$ovar->{'longtime'});

if ($debug) { print "date=$gvar->{'date'}\n"; }
if ($debug) { print "date=$gvar->{'sqldate'}\n"; }


#######################################
#     Read in Form Data
#######################################
my %VALUES = &genlib::ParseData();

&genlib::SetUpTemplates("$config{'HtmlTemplates'}");

# Remove whitespace from username
$VALUES{'username'} =~ s/\s*//g;
$VALUES{'password'} =~ s/\s*//g;
$VALUES{'confirmpassword'} =~ s/\s*//g;

# dropdowns or checkboxes fix return values for validation
my($var1);
$var1 = join("_", "slc_state", $VALUES{'state'});
$ovar->{$var1} = "selected";


my($key) = '';
foreach $key (keys %VALUES) {
   $ovar->{$key} = $VALUES{$key};
}

# Custom Set state id
#ovar->{'fields'}=qq(<input type="hidden" name="stateid" value="$VALUES{'stateid'}">);

my($RegisterHtml) = '';  my($ValidateFlds) = '';  my($customcheck1)='';
my($register_table) = ''; my($user_table) = '';
my(@data_var) = ();      my(@data_form) = ();      my($miscell_table) = '';

$RegisterHtml = "register.htm";
$ValidateFlds = $gvar->{'ValidFlds'};
$register_table = 'register';
$user_table = 'user';
$miscell_table = 'recovery';
(@data_var) = split(/:/,$gvar->{'Data'});
#(@data_form) = split(/:/,$gvar->{'Data_Form'});


#######################################
#      Validatation
#######################################
if ($customcheck1) {
}

my($strng);
if ($strng = &genlib::ChkEmptyFields(\%VALUES, $ValidateFlds)) {

   if ($debug) {
      my($key) = '';
      foreach $key (keys %{$ovar}) {
         print " ovar in reg $key = $ovar->{$key}\n";
      }
   }

   $ovar->{'password'} = '';
   $ovar->{'confirmpassword'} = '';
   $ovar->{'message'}=join('',$gvar->{'registermessage1'}, "<b> $strng.</b>");
   &genlib::RtrnPage("$config{'HtmlTemplates'}/$RegisterHtml");

   exit(0);
}

# Check if buyer or other selected for buyer page
#######################################
#      Validate e-mail field
#######################################
if ($VALUES{'email'}) {
   my($ValMsg) = '';
   if ( ($ValMsg = &genlib::ValEmail($VALUES{'email'})) ) {
       $ovar->{'password'} = '';
       $ovar->{'confirmpassword'} = '';
       $ovar->{'message'} = $ValMsg;
       &genlib::RtrnPage("$config{'HtmlTemplates'}/$RegisterHtml");
       exit(0);
   }
}

#######################################
#      Reformat textarea tag
#######################################
#my($Comments) = '';
#if ($VALUES{'Comments'}) {
#   my(@comments, $ln);
#   @comments = &ParseTxt($VALUES{'Comments'});
#   $Comments="";
#   foreach $ln (@comments) {
#      $Comments .= $ln;
#   }
#}

my(@row) = ();  my($test) = ''; my($continue) = 1;
my($tryuser) = my($username) = $VALUES{'username'};  my($ncnt) = 1;

# Find if user already has an entry in the registration table using stateid
# accomodates for use of back-button - if so skip check of userid since it
# exists.
#my($stateid) = $VALUES{'stateid'};

my($AppendRecord) = 1;

# Check username by default
my($CheckUsername) = 1;

my($old_username) = '';
#if (&FindRecord($register_table, "stateid", "stateid='$stateid'",\@row ) ) {
#   $AppendRecord = 0;
#   $old_username = $row[$cvar->{'RG_USERNAME'}];
#   if ($row[$cvar->{'RG_USERNAME'}] ne $VALUES{'username'}) {
#      $CheckUsername = 1;
#   }
#   else {
#      # No change
#      $CheckUsername = 0;
#   }
#   if ($debug) { print "Checkusername=$CheckUsername\n"; }
#}



if ($CheckUsername) {
   # Find if user name already exist then suggest something different
   if ( &FindRecord($user_table, "username", "username='$username'",\@row ) ) {
      while ($continue) {
         $tryuser = join("", $tryuser, $ncnt);
         $ncnt++;

         $test=&FindRecord($user_table, "username", "username='$tryuser'",\@row );

         if ($test) {
            next;
         }
         else {
            # Try another
            last;
         }

         if ($ncnt > 1000) {
            &genlib::SysError('register.cgi', 'Infinite Loop -    Contact Webmaster');
         }
      }
      $ovar->{'password'} = '';
      $ovar->{'confirmpassword'} = '';
      $ovar->{'message'} =    "Username $VALUES{'username'} is taken. Please enter an   other. Try $tryuser.";

      &genlib::RtrnPage("$config{'HtmlTemplates'}/$RegisterHtml");
      exit(0);
   }
}


@row = ();
# Check username first
my $email = $VALUES{'email'};
if ( (&FindRecord('register',"*","email='$email'",\@row )) ) {
   $ovar->{'message'} = $gvar->{'registermessage4'};
   $ovar->{'password'} = '';
   $ovar->{'confirmpassword'} = '';
   &genlib::RtrnPage("$config{'HtmlTemplates'}/$RegisterHtml");
   &CloseDBI();
   exit(0);
}



# Set additional fields - date fields and activation
$VALUES{'registerdate'} = $gvar->{'sqldate'};
$VALUES{'updatedate'} = $gvar->{'sqldate'};
# Default - in table user
$VALUES{'activate'} = '1';
#$VALUES{'stateid'} = '';


my($fields) = '';
$VALUES{'id'} ='';
# Both are zeroed

#if ($VALUES{'creditcard'}) {
#
#   my($key) = '';
#  #foreach $key (@data_form) {
  #   $ovar->{'fields'} .=qq(<input type="hidden" name="$key" value="$VALUES{$key}">);
  #}
#  $ovar->{'fields'}=qq(<input type="hidden" name="x_First_Name" value="$VALUES{'stateid'}">);
#}
#elsif ($VALUES{'cheque'}) {
   # Set to activate for testing
# Future $VALUES{'payment'} = 2;

   if ($VALUES{'activate'}) {
      # Calculate expiry date by seconds
      $VALUES{'activatedate'} = $gvar->{'sqldate'};


      if (!$gvar->{'ignore_expirydate'}) {
         my $tm_today =  &genlib::SqlDtToSec($VALUES{'activatedate'});
         my $tm_nextyear = $tm_today + ($gvar->{'expirytime_in_days'}*24*3600);
         my (@timedata) = localtime($tm_nextyear);
         my $year = join('', $gvar->{'decade'}, substr($timedata[5], 1, 2) );
         if($debug) { print "yr=$timedata[5]\n"; }
         if($debug) { print "mth=$timedata[4]\n"; }
         if($debug) { print "dy=$timedata[3]\n"; }
         $VALUES{'expirydate'} = join('-', $year, $timedata[4]+1, $timedata[3]);
      }
      else {
         $VALUES{'expirydate'} = '0000-00-00';
      }
   }
#}


if($debug) { print "registerdate=$VALUES{'registerdate'}\n"; }
if($debug) { print "expdate=$VALUES{'expirydate'}\n"; }


my(@data_users) = ();
if ($AppendRecord) {
   # Create Password for both cheque and credit card
   if ($gvar->{'CreatePassword'}) {
      $ovar->{'password'} = $VALUES{'password'} = &genlib::CreatePass(3,8);
   }
   else {
      if ($VALUES{'password'} ne $VALUES{'confirmpassword'}) {
         $ovar->{'password'} = '';
         $ovar->{'confirmpassword'} = '';
         $ovar->{'message'} = $gvar->{'registermessage2'};
         &genlib::RtrnPage("$config{'HtmlTemplates'}/$RegisterHtml");
         &CloseDBI();
         exit(0);
      }
      my $len_p = length($VALUES{'password'});
      if ($len_p < $gvar->{'PasswordMinimum'}) {
         $ovar->{'password'} = '';
         $ovar->{'confirmpassword'} = '';
         $ovar->{'message'} = $gvar->{'registermessage3'};
         &genlib::RtrnPage("$config{'HtmlTemplates'}/$RegisterHtml");
         &CloseDBI();
         exit(0);
      }
      if ($len_p > $gvar->{'PasswordMaximum'} ) {
         $ovar->{'password'} = '';
         $ovar->{'confirmpassword'} = '';
         $ovar->{'message'} = $gvar->{'registermessage3'};
         &genlib::RtrnPage("$config{'HtmlTemplates'}/$RegisterHtml");
         &CloseDBI();
         exit;
      }
   }
   if ($debug) { print "password = $VALUES{'password'}\n"; }

   # Verify confirm password equals password


   # Encrypt Password
   my $salt = substr($VALUES{'password'},0,2);
   $VALUES{'cryptpass'} = crypt($VALUES{'password'}, $salt);


   if($debug) { print "activate=$VALUES{'activate'}\n"; }
   # Append to registration  file

   &Appnd($register_table, \@data_var, \%VALUES);

   $VALUES{'timein'} = '';

   @data_users = ();
   # Append to users file
   $data_users[0] = 'username';
   $data_users[1] = 'cryptpass';
   $data_users[2] = 'expirydate';
   $data_users[3] = 'timein';
   $data_users[4] = 'activate';
   &Appnd($user_table, \@data_users, \%VALUES);

   @data_users = ();
   $data_users[0] = 'username';
   $data_users[1] = 'password';
   $data_users[2] = 'reminder';
   # Append to password recovery file
   $VALUES{'passkey'} = $VALUES{'reminder'};
   &Appnd($miscell_table, \@data_users, \%VALUES);
}
#else {
   # Update Record
#   my($stateid) = $VALUES{'stateid'};
#   &UpDtData($register_table, \@data_var, \%VALUES, "stateid='$stateid'");

#   @data_users = ('username');
#   &UpDtData($user_table, \@data_users, \%VALUES, "username='$old_username'");

#   @data_users = ('username');
#  &UpDtData($miscell_table, \@data_users, \%VALUES, "username='$old_username'"#);


    # Get password for e-mail
#  my(@row) = ();
#  my ($username) = $VALUES{'username'};
#  if (!&FindRecord($miscell_table, "password", "username='$username'",\@row ) ) {
#     &genlib::SysError('register2.cgi', 'Password not found. Contact the Webmaster');
#  }
#  $ovar->{'password'} = $row[$cvar->{'PASSWORD'}];
#
#
#}

my($finalpage) = '';
$ovar->{'loginURL'} = $gvar->{'loginURL'};

#if ($VALUES{'creditcard'}) {
#   $finalpage = $RegisterHtml2;
#}
#elsif ($VALUES{'cheque'}) {
   # Send appropriate e-mails
   # Set to activate for testing
   $ovar->{'paymenttype'} = 'Check';
   my($EmailTemplate) = '';  my($FN_EmailTemplate) = '';

   $finalpage=$gvar->{'ResponsePage'};


      # Send to customer

      if ($VALUES{'email'}) {


         if ($gvar->{'MailType'} == 0) {

            &genlib::SendUnixMail($VALUES{'email'},
                          $gvar->{'MEMBER_EmailFrom'},
                          $gvar->{'MEMBER_EmailFromAdd'},
                          $gvar->{'MEMBER_EmailSubject'},
                          $gvar->{'MEMBER_EmailCC'},
                          "$config{'HtmlTemplates'}/$gvar->{'MEMBER_EmailTemplate'}"
                      );
         }
         else {
            &genlib::SendSmtpMail($VALUES{'email'},
                          $gvar->{'MEMBER_EmailFrom'},
                          $gvar->{'MEMBER_EmailFromAdd'},
                          $gvar->{'MEMBER_EmailSubject'},
                          $gvar->{'MEMBER_EmailCC'},
                          "$config{'HtmlTemplates'}/$gvar->{'MEMBER_EmailTemplate'}"
                      );

         }
      }
      # Send to store
      if ($gvar->{'MailType'} == 0) {
         &genlib::SendUnixMail($gvar->{'ADMIN_EmailTo'},
                       $gvar->{'ADMIN_EmailFrom'},
                       $gvar->{'ADMIN_EmailFromAdd'},
                       $gvar->{'ADMIN_EmailSubject'},
                       $gvar->{'ADMIN_EmailCC'},
                       "$config{'HtmlTemplates'}/$gvar->{'ADMIN_EmailTemplate'}"
                      );
      }
      else {
         &genlib::SendSmtpMail($gvar->{'ADMIN_EmailTo'},
                       $gvar->{'ADMIN_EmailFrom'},
                       $gvar->{'ADMIN_EmailFromAdd'},
                       $gvar->{'ADMIN_EmailSubject'},
                       $gvar->{'ADMIN_EmailCC'},
                       "$config{'HtmlTemplates'}/$gvar->{'ADMIN_EmailTemplate'}"
                      );
      }

#}


&CloseDBI();


if($debug) { print "finalpage=$finalpage\n"; }
&genlib::InitializeOut();
&genlib::RdOutFile("$config{'HtmlTemplates'}/$gvar->{'ResponsePage'}");

exit;
