#!/usr/bin/perl
#  application: SQL QuickRegister Password Management System
#       script: startup_quickregister.pl
#      Version: March/2002 1.0
#       author: David Jourard
#               Bytes Interactive
#               http://www.bytesinteractive.com
#               cgi@bytesinteractive.com
# requirements: perl 5 Unix Version and mySQL
#
#
#  description: startup functions
# ***************************************************************************
# SQL QuickRegister
# COPYRIGHT NOTICE
# Copyright 2002 David Jourard  All Rights Reserved.
#
# This program cannot be used till one reads and agrees the terms of the license
# defined in the file license.txt which comes with the software.
#*****************************************************************************
use strict;
use vars qw($gvar  $ovar $cvar %config %VALUES $debug $dbh %QEVar @othertemplates);

$config{'database'}   = 'quickregister';
$config{'server'}     = 'localhost';
$config{'username'}   = '';
$config{'password'}   = '';

$config{'adminpassword'} = "12345678";

# action parameter to get to login for admin
# make this as random as possible
$config{'admin_login'} = "u832";


# Configure Paths
# 1. Find cgi-bin/quickregister path
if ($ENV{'SCRIPT_FILENAME'}) {
   $config{'CgiBinPath'} = $ENV{'SCRIPT_FILENAME'};
   $config{'CgiBinPath'} =~ s/\\\\/\\/g;
   $config{'CgiBinPath'} =~ s/\\/\//g;
   $config{'CgiBinPath'} =~ s/(\/)(\w*)(\.*)(\w+)$//g;
   if ($debug) { print "CgiBinPath=$config{'CgiBinPath'}\n"; }
}
else {
   # Hardcode the path then comment these 5 lines out
   print STDOUT "Content-type: text/html\n\n"; #1.
   print qq(<HTML><HEAD></HEAD><BODY>); #2.
   print qq(<br><br><h2> System Error<BR>Environment Variable SCRIPT_FILENAME not defined.<br> Set the paths manually); #3.
   print qq(</h2></body></html>); #4.
   exit; #5.
}
$config{'CgiBinPath'} =~ s/ //g;
$config{'CgiBinPath'} =~ s/\n//g;


if ($ENV{'DOCUMENT_ROOT'}) {
   $config{'DocumentRoot'} = $ENV{'DOCUMENT_ROOT'};
   $config{'DocumentRoot'} =~ s/\\\\/\\/g;
   $config{'DocumentRoot'} =~ s/\\/\//g;
   if ($debug) { print "DocumentRoot=$config{'DocumentRoot'}\n"; }
}
else {
   # Hardcode the path then comment these 5 lines out
   print STDOUT "Content-type: text/html\n\n"; # 1.
   print qq(<HTML><HEAD></HEAD><BODY>); # 2.
   print qq(<br><br><h2> System Error<BR>Environment Variable DOCUMENT_ROOT not defined.<br> Set the paths manually.); #3.
   print qq(</h2></body></html>); #4.
   exit; #5.
   # FOR UNIX
   # Path to the root of your quiz subdirectories
   #$config{'DocumentRoot'} = "/usr/www/users/yourdomain/htdocs";
   #$config{'DocumentRoot'}="/www/userid/public_html/quizzes";
   #$config{'DocumentRoot'}="/www/userid/htdocs/quizzes";
   #$config{'DocumentRoot'}="/www/userid/www/quizzes";
   #$config{'DocumentRoot'}="/www/userid/docs/quizzes";
}
$config{'DocumentRoot'} =~ s/ //g;
$config{'DocumentRoot'} =~ s/\n//g;

# Remove scripts from cgibin path
$config{'CgiBinPath'} =~ s/(\/)(\w*)(\.*)(\w+)$//g;

#-$config{'HtmlPath'} = "c:\\apache\\htdocs\\quizengine_register";
$config{'HtmlTemplates'} = join('/', $config{'CgiBinPath'},'templates');

#-$config{'HtmlPath'} = "c:\\apache\\htdocs\\quizengine_register";
$config{'DataPath'} = join('/', $config{'CgiBinPath'},'data');


############################
# Global Constants
############################

# Initialize global arrays
$gvar = {};
$ovar = {};
$cvar = {};


$QEVar{'LONGDATE'} = 'longdate';
$QEVar{'LONGTIME'} = 'longtime';
$QEVar{'MESSAGE'} = 'message';
$QEVar{'USERNAME'} = 'username';
$QEVar{'FOOTER'} = 'footer';

# Field order in table user
$cvar->{'USERNAME'} = 0;
$cvar->{'PASSWORD'} = 1;
$cvar->{'EXPIRY_DATE'} = 2;
$cvar->{'TIMEIN'} = 3;
$cvar->{'ACTIVATE'} = 4;

sub ModifyConfig {
   my $ra_othertemplates = $_[0];
   my $rh_QEVar = $_[1];

  if ($debug) { print "ModifyConfig ...templates=$gvar->{'othertemplates'}\n"; }

   (@{$ra_othertemplates}) = split(/:/, $gvar->{'othertemplates'});
   my($tpl)=''; my($tpl2)='';  my($tpl3)=''; my($ext) = '';
   foreach $tpl (@othertemplates) {
      ($tpl2, $ext) = split(/\./, $tpl);
      $tpl3 = "\U$tpl2";
      #if ($main::debug) { print "tpl=$tpl\n"; }
      #if ($main::debug) { print "tpl3=$tpl3\n"; }
      $$rh_QEVar{$tpl3}=$tpl2;
   }

   return 1;
}

1;
