#!/usr/bin/perl
# usually active state version
# C:/Perl/bin/perl.exe
# usually a mod_perl version
# C:/Perl/5.6.0/bin/MSWin32-x86/perl.exe
#  application: SQL QuickRegister Password Management System
#       script: update_profile.cgi
#      Version: March/2002 1.0
#       author: David Jourard
#               Bytes Interactive
#               http://www.bytesinteractive.com
#               cgi@bytesinteractive.com
# requirements: perl 5 Unix Version and mySQL
#
#
#  description: admin update of client
# ***************************************************************************
# SQL QuickRegister
# COPYRIGHT NOTICE
# Copyright 2002 David Jourard  All Rights Reserved.
#
# This program cannot be used till one reads and agrees the terms of the license
# defined in the file license.txt which comes with the software.
#*****************************************************************************
#Clears data if connection is broken
$|= 1;

use strict;
use vars qw($gvar $cvar $ovar %config $debug $dbh %QEVar @othertemplates);
use Time::Local;

$debug=0;
if ($debug) {
   print STDOUT "Content-type: text/plain\n\n";
}

#######################################
#     Call Perl Libraries
#######################################
require "startup_quickregister.pl";
require "genlib.pl";
require "mysqllib.pl";

&genlib::OpenParam("$config{'DataPath'}/config.txt", $gvar);
&genlib::OpenParam("$config{'DataPath'}/messages.txt", $gvar);

&ModifyConfig(\@othertemplates, \%QEVar);

&genlib::OpenParam("$config{'DataPath'}/register_fields.txt", $cvar);

#######################################
#     Open parameter table
#######################################
&genlib::OpenParam("$config{'DataPath'}/register.txt", $gvar);

#######################################
#     Verify Login Ticket
#######################################
my ($result) = ''; my($message) = ''; my $username=''; my $sessiontime = '';
($result, $message, $username, $sessiontime) = &genlib::VerifyLoginTicket();
if ($result == 0) {
   $ovar->{'message'} = $message;
   &genlib::SetUpTemplates("$config{'HtmlTemplates'}");

   &genlib::InitializeOut();
   &genlib::RdOutFile("$config{'HtmlTemplates'}/$gvar->{'LoginHtml1'}");
   exit;
}

$ovar->{'username'} = $username;

#######################################
#     Open DBI Connection
#######################################
&SetDBI();

###########################################
#   Prepare date and time for registration
###########################################
&genlib::CreateDate(\$gvar->{'time'},\$ovar->{'longdate'},\$gvar->{'date'},\$gvar->{'shortdate2'}, \$gvar->{'sqldate'}, \$ovar->{'longtime'});


#######################################
#     Read in Form Data
#######################################
my %VALUES = &genlib::ParseData();

&genlib::SetUpTemplates("$config{'HtmlTemplates'}");

# use for user update
#my %aCookies = &GetCookies();  my($stateid) = '';
#if (!$aCookies{'stateid'}) {
#   $stateid = $VALUES{'stateid'};
#}
#else {
#   $stateid = $aCookies{'stateid'};
#}
#$ovar->{'fields'} = qq(<input name="stateid" value="$stateid" type="hidden">);

# dropdowns or checkboxes fix return values for validation
my($var1) = '';
$var1 = join("_", "slc_state", $VALUES{'state'});
$ovar->{$var1} = "selected";
$var1 = join("_", "slc_country", $VALUES{'country'});
$ovar->{$var1} = "selected";

$QEVar{'EXPIRYDATE'} = 'expirydate';
$QEVar{'UPDATEDATE'} = 'updatedate';
$QEVar{'REGISTERDATE'} = 'registerdate';

$QEVar{'USERNAME'} = 'username';
$QEVar{'FIELDS'} = 'fields';



my($key) = '';
foreach $key (keys %VALUES) {
   $ovar->{$key} = $VALUES{$key};
}

my($RegisterHtml) = '';  my($ValidateFlds) = '';  my($customcheck1)='';
my(@data_form) = ();
$RegisterHtml = $gvar->{'UpdtRegisterUser'};
$ValidateFlds = $gvar->{'ValidFldsUpDt'};
(@data_form) = split(/:/,$gvar->{'Data_UpDt'});
$customcheck1=1;

#######################################
#      Validatation
#######################################
if ($customcheck1) {
}

# Find old record
my(%OLD_VALUES) = ();
my @row = (); my @fldnames = ();
if (!&FindRecord('register', "*", "username='$username'", \@row, \@fldnames)) {;
   $ovar->{'message'} = "register - $gvar->{'updateadminmessage1'}";
   &genlib::SysError('update_admin', $ovar->{'message'});
   &CloseDBI();
   exit(0);
}
my($fld) = ''; my($ni) = 0;
foreach $fld (@fldnames) {
   $OLD_VALUES{$fld} = $row[$ni++];
}

$ovar->{'expirydate'} = $row[$cvar->{'expirydate'}-1];
$ovar->{'registerdate'} = $row[$cvar->{'registerdate'}-1];

my($strng);
if ($strng = &genlib::ChkEmptyFields(\%VALUES, $ValidateFlds)) {

   if ($debug) {
      my($key) = '';
      foreach $key (keys %{$ovar}) {
         print " ovar in reg $key = $ovar->{$key}\n";
      }
   }

   $ovar->{'message'} = "You need to fill in your <b> $strng.</b>";
   &genlib::RtrnPage("$config{'HtmlTemplates'}/$RegisterHtml");

   exit(0);
}


#######################################
#      Validate e-mail field
#######################################
if ($VALUES{'email'}) {
   my($ValMsg) = '';
   if ( ($ValMsg = &genlib::ValEmail($VALUES{'email'})) ) {
       $ovar->{'message'} = $ValMsg;
       &genlib::RtrnPage("$config{'HtmlTemplates'}/$RegisterHtml");
       exit(0);
   }
}


#######################################
#      Update Records
#######################################
my(@data) = ();  my(@datauser) = ();  my(%FldType) = ();
# Create Update String.

# 1. General form fields
$ni = -1;
my $nj = -1;
my($updt) = 0;
my($updtuser) = 0;
foreach $fld (@data_form) {
   if ($VALUES{$fld} ne $OLD_VALUES{$fld}) {
      if ($debug) { print "new $fld=$VALUES{$fld}\n"; }
      if ($debug) { print "old $fld=$OLD_VALUES{$fld}\n"; }
      $ni++;
      $data[$ni] = $fld;
      $updt = 1;
   }
}

if ($updt) {
   # Update register
   $VALUES{'updatedate'} = $gvar->{'sqldate'};
   $ni++;
   $data[$ni] = 'updatedate';
   &UpDtData('register', \@data, \%VALUES, "username='$username'");
}

# Update mother's maiden name
@row = ();
&FindRecord('recovery', "reminder", "username='$username'", \@row );
if ($row[0] ne $VALUES{'reminder'}) {
   # Update
   @data = ();
   $data[0] = 'reminder';
   &UpDtData('recovery', \@data, \%VALUES, "username='$username'");
}
&genlib::UpDtSessionTime($username);

$QEVar{'LONGDATE'} = 'longdate';
$QEVar{'LONGTIME'} = 'longtime';
$QEVar{'FIRSTNAME'} = 'firstname';
$QEVar{'LASTNAME'} = 'lastname';
($ovar->{'firstname'}, $ovar->{'lastname'}) = &GetName($username);

&CloseDBI();


&genlib::InitializeOut();
&genlib::RdOutFile("$config{'HtmlTemplates'}/$gvar->{'ResponsePageLogin'}");

exit;
