#!/usr/bin/perl
# usually active state version
# C:/Perl/bin/perl.exe
# usually a mod_perl version
# C:/Perl/5.6.0/bin/MSWin32-x86/perl.exe
#  application: SQL QuickRegister Password Management System
#       script: update_registrant.cgi
#      Version: March/2002 1.0
#       author: David Jourard
#               Bytes Interactive
#               http://www.bytesinteractive.com
#               cgi@bytesinteractive.com
# requirements: perl 5 Unix Version and mySQL
#
#
#  description: admin update of client
# ***************************************************************************
# SQL QuickRegister
# COPYRIGHT NOTICE
# Copyright 2002 David Jourard  All Rights Reserved.
#
# This program cannot be used till one reads and agrees the terms of the license
# defined in the file license.txt which comes with the software.
#*****************************************************************************
#Clears data if connection is broken
$|= 1;

use strict;
use vars qw($gvar $cvar $ovar %config $debug $dbh %QEVar @othertemplates);
use Time::Local;

$debug=0;
if ($debug) {
   print STDOUT "Content-type: text/plain\n\n";
}

#######################################
#     Call Perl Libraries
#######################################
require "startup_quickregister.pl";
require "genlib.pl";
require "mysqllib.pl";

&genlib::OpenParam("$config{'DataPath'}/config.txt", $gvar);
&genlib::OpenParam("$config{'DataPath'}/messages.txt", $gvar);

&ModifyConfig(\@othertemplates, \%QEVar);

#######################################
#     Verify Login Ticket
#######################################
my ($result) = ''; my($message) = '';
($result, $message) = &genlib::VerifyLoginTicket_Type3();
if ($result == 0) {
   $ovar->{'message'} = $message;
   &genlib::SetUpTemplates("$config{'HtmlTemplates'}");

   &genlib::InitializeOut();
   &genlib::RdOutFile("$config{'HtmlTemplates'}/admin_login.htm");
   exit;
}

#######################################
#     Open parameter table
#######################################
&genlib::OpenParam("$config{'DataPath'}/register.txt", $gvar);

#######################################
#     Open DBI Connection
#######################################
&SetDBI();

###########################################
#   Prepare date and time for registration
###########################################
&genlib::CreateDate(\$gvar->{'time'},\$ovar->{'longdate'},\$gvar->{'date'},\$gvar->{'shortdate2'}, \$gvar->{'sqldate'}, \$ovar->{'longtime'});


#######################################
#     Read in Form Data
#######################################
my %VALUES = &genlib::ParseData();

&genlib::SetUpTemplates("$config{'HtmlTemplates'}");

my($key) = '';
foreach $key (keys %VALUES) {
   $ovar->{$key} = $VALUES{$key};
}
my $username=$VALUES{'username'};


# use for user update
#my %aCookies = &GetCookies();  my($stateid) = '';
#if (!$aCookies{'stateid'}) {
#   $stateid = $VALUES{'stateid'};
#}
#else {
#   $stateid = $aCookies{'stateid'};
#}
#$ovar->{'fields'} = qq(<input name="stateid" value="$stateid" type="hidden">);

# dropdowns or checkboxes fix return values for validation
my($var1) = '';
$var1 = join("_", "slc_state", $VALUES{'state'});
$ovar->{$var1} = "selected";
$var1 = join("_", "slc_country", $VALUES{'country'});
$ovar->{$var1} = "selected";

if ($VALUES{'activate'} == 1) {
   $ovar->{'activate'} = "checked";
}
$ovar->{'username'} = $VALUES{'username'};
$ovar->{'fields'} = qq(<input type="hidden" name="username"
value="$VALUES{'username'}">);
$ovar->{'fields'} .= qq(<input type="hidden" name="letter" value="$VALUES{'letter'}">);
$ovar->{'fields'} .= qq(<input type="hidden" name="registerdate" value="$ovar->{'registerdate'}">);
$ovar->{'fields'} .= qq(<input type="hidden" name="activatedate"  value="$ovar->{'activatedate'}">);
$ovar->{'fields'} .= qq(<input type="hidden" name="updatedate"     value="$ovar->{'updatedate'}">);

$QEVar{'ACTIVATEDATE'} = 'activatedate';
$QEVar{'UPDATEDATE'} = 'updatedate';
$QEVar{'REGISTERDATE'} = 'registerdate';

$QEVar{'USERNAME'} = 'username';
$QEVar{'FIELDS'} = 'fields';


my($RegisterHtml) = '';  my($ValidateFlds) = '';  my($customcheck1)='';
my(@data_form) = ();
$RegisterHtml = $gvar->{'UpdtRegister'};
$ValidateFlds = $gvar->{'ValidFldsUpDt'};
(@data_form) = split(/:/,$gvar->{'Data_UpDt'});
$customcheck1=1;

#######################################
#      Validatation
#######################################
if ($customcheck1) {
}

my($strng);
if ($strng = &genlib::ChkEmptyFields(\%VALUES, $ValidateFlds)) {

   if ($debug) {
      my($key) = '';
      foreach $key (keys %{$ovar}) {
         print " ovar in reg $key = $ovar->{$key}\n";
      }
   }

   $ovar->{'message'} = "You need to fill in your <b> $strng.</b>";
   &genlib::RtrnPage("$config{'HtmlTemplates'}/$RegisterHtml");

   exit(0);
}


#######################################
#      Validate e-mail field
#######################################
if ($VALUES{'email'}) {
   my($ValMsg) = '';
   if ( ($ValMsg = &genlib::ValEmail($VALUES{'email'})) ) {
       $ovar->{'message'} = $ValMsg;
       &genlib::RtrnPage("$config{'HtmlTemplates'}/$RegisterHtml");
       exit(0);
   }
}


#######################################
#      Update Records
#######################################
if (!$VALUES{'nactivate'}) {
   $VALUES{'nactivate'} = 0;
}


my(%OLD_VALUES) = ();
my @row = (); my @fldnames = ();
if (!&FindRecord('register', "username", "username='$username'", \@row, \@fldnames)) {;
   $ovar->{'message'} = "register - $gvar->{'updateadminmessage1'}";
   &genlib::SysError('update_admin', $ovar->{'message'});
   &CloseDBI();
   exit(0);
}
my($fld) = ''; my($ni) = 0;
foreach $fld (@fldnames) {
   $OLD_VALUES{$fld} = $row[$ni++];
}

my(@data) = ();  my(@datauser) = ();  my(%FldType) = ();
# Create Update String.

# 1. General form fields
$ni = -1;
my $nj = -1;
my($updt) = 0;
my($updtuser) = 0;
foreach $fld (@data_form) {
   if ($VALUES{$fld} ne $OLD_VALUES{$fld}) {
      if ($debug) { print "new $fld=$VALUES{$fld}\n"; }
      if ($debug) { print "old $fld=$OLD_VALUES{$fld}\n"; }
      $ni++;
      $data[$ni] = $fld;
      $updt = 1;
   }
}

# 2. Expiry date
if ($OLD_VALUES{'expirydate'} ne $VALUES{'expirydate'}) {
   $updt = 1;
   $ni++;
   $data[$ni] = 'expirydate';

   $updtuser = 1;
   $nj++;
   $datauser[$nj] = 'expirydate';
   $FldType{'expirydate'} = 'C';

}

# 2. Activate date get info from user
my @userrow = (); @fldnames = ();
if (!&FindRecord('user', "*", "username='$username'", \@userrow, \@fldnames)) {;
   $ovar->{'message'} = "user - $gvar->{'updateadminmessage1'}";
   &genlib::SysError('update_admin.cgi', $ovar->{'message'});
   &CloseDBI();
   exit(0);
}
if ($userrow[$cvar->{'ACTIVATE'}] ne $VALUES{'activate'}) {
   # changing status
   $updt=1;
   $VALUES{'activatedate'} = $gvar->{'sqldate'};
   $ni++;
   $data[$ni] = 'activatedate';

   $updtuser=1;
   $nj++;
   $datauser[$nj] = 'activate';
   $FldType{'activate'} = 'N';
}

if ($updt) {
   # Update register
   $VALUES{'updatedate'} = $gvar->{'sqldate'};
   $ni++;
   $data[$ni] = 'updatedate';
   &UpDtData('register', \@data, \%VALUES, "username='$username'");
}

if ($updtuser) {
   # Update user
   &UpDtm('user', \@datauser, \%VALUES, \%FldType, "username='$username'");
}


# Update mother's maiden name
@row = ();
&FindRecord('recovery', "reminder", "username='$username'", \@row );
if ($row[0] ne $VALUES{'reminder'}) {
   # Update
   @data = ();
   $data[0] = 'reminder';
   &UpDtData('recovery', \@data, \%VALUES, "username='$username'");
}


$QEVar{'LONGTIME'} = 'longtime';
$QEVar{'LONGDATE'} = 'longdate';
&UpDtUsersTable($VALUES{'letter'});

&CloseDBI();
exit;
